﻿@page "/burn"

@using AntDesign
@using System.Text
@using FIOWeb.Models
@using FIOWeb.JsonPayloads
@using Newtonsoft.Json
@using CurrieTechnologies.Razor.Clipboard

@inject NavigationManager NavManager
@inject GlobalAppState GlobalAppState
@inject ClipboardService Clipboard
@inject IMatToaster Toaster

@implements IDisposable

<FIOWeb.Components.LoadingWrapper RequiresAuth="true" @bind-ProgressCount="ProgressCount" TotalProgress="1">
@if (BurnModels == null && CannotSeeUsersData )
{
<h1>Unable to View Specified Users Data</h1>
}
else
{
<h1>Burn - @ActiveUserName @ActiveGroup</h1>
<MatIconButton Style="outline:0" Icon="refresh" OnClick="@(() => { _ = Refresh(); })"></MatIconButton>

<FIOWeb.Components.UserOrGroup AllowancesRequired="@RequiredAllowances" SupportsGroups="true" 
    @bind-CurrentUserName="ActiveUserName" @bind-CurrentGroup="ActiveGroup" 
    UserNameSelectionChanged="@(() => { ActiveGroup = null; _ = Refresh(); } )"
    GroupSelectionChanged="@(() => { ActiveUserName = null; _ = Refresh(); } )"/>

<br/>

bool ShouldShowUserNames = (ActiveUserName == null);

@if(ShouldShowUserNames)
{
<FIOWeb.Components.UrlFilter Placeholder="User Filter" URLQueryKey="Users" @bind-SelectedOptions="@FilteredUsers" AllOptions="AllAvailableUsers" FilterChanged="ApplyFilters"/><br/>
<br/>
}
<FIOWeb.Components.UrlFilter Placeholder="Ticker Filter" URLQueryKey="Tickers" @bind-SelectedOptions="@FilteredTickers" AllOptions="AllAvailableTickers" FilterChanged="ApplyFilters"/><br/><br/>
<FIOWeb.Components.UrlFilter Placeholder="Planet Filter" URLQueryKey="Planets" @bind-SelectedOptions="@FilteredPlanets" AllOptions="AllAvailablePlanets" FilterChanged="ApplyFilters"/><br/><br/>

<div style="width:100%">
    <div class="flex-container"style="display: flex; flex-flow: row wrap; justify-content: flex-start">
        <RadioGroup style="margin-top:auto" @bind-Value="DisplayMode" Size="small">
            <Radio RadioButton Value="@("ShowAll")">All</Radio>
            <Radio RadioButton Value="@("ShowOnlyWorkforce")">Workforce Only</Radio>
            <Radio RadioButton Value="@("ShowOnlyProduction")">Orders Only</Radio>
        </RadioGroup>
        <div>&nbsp;&nbsp;</div>
        <MatNumericUpDownField Style="width:150px; padding: 10px 10px 10px 10px" Label="Yellow Threshold"
                                @bind-Value=@YellowThreshold
                                DecimalPlaces=0
                                Minimum=@ThresholdMin Maximum=@ThresholdMax>
        </MatNumericUpDownField>
        <div>&nbsp;</div>
        <MatNumericUpDownField Style="width:150px; padding: 10px 10px 10px 10px" Label="Red Threshold"
                                @bind-Value=@RedThreshold
                                DecimalPlaces=0
                                Minimum=@ThresholdMin Maximum=@ThresholdMax>
        </MatNumericUpDownField>
    </div>
</div>

<Table DataSource="BurnModels"
       TreeChildren="item => item.Children"
       PageSize="50"
       Size=@TableSize.Small
       TItem="BurnModel"
       Bordered="true">
    <Column Width="250" TData="string" @bind-Field="@context.PlanetDisplayName" Title="Planet" Sortable="true" SorterCompare="@((v1, v2) => BurnModel.ComparePlanetDisplayNames(v1, v2))">
        @if (ShouldShowUserNames && !String.IsNullOrEmpty(context.PlanetDisplayName))
        {
        <Popover Placement="@Placement.RightTop" Title="">
            <ContentTemplate>
                <div>
                @{string OnPlanet = string.Join("<br/>", BurnModels.Where(bm => bm.PlanetNaturalId == context.PlanetNaturalId).SelectMany(bm => bm.AllPlanetUsers).Distinct().ToList());}
                @((MarkupString)OnPlanet)
                </div>
            </ContentTemplate>
            <ChildContent>
                @context.PlanetDisplayName
            </ChildContent>
        </Popover>
        }
        else
        {
        @context.PlanetDisplayName
        }
    </Column>
    <Column Width="75" TData="string" title="Material" Sortable="false">
        @context.MaterialTicker
    </Column>
    <Column Width="75" TData="string" title="Burn" Sortable="false">
        @if (context.Parent != null)
        {
        string UserWorkforceConsumptions = "<b>Workforce Consumption:</b><br/>" + string.Join("<br/>", context.UserWorkforceConsumptions);
        string UserOrderConsumptions = "<b>Order Consumption:</b><br/>" + string.Join("<br/>", context.UserOrderConsumptions);

        string AllUsersBurnStr = "";
        @if (context.UserWorkforceConsumptions.Count > 0)
        {
            AllUsersBurnStr += UserWorkforceConsumptions + "<br/>";
        }
        @if (context.UserOrderConsumptions.Count > 0)
        {
            AllUsersBurnStr += UserOrderConsumptions;
        }

        <Popover Placement="@Placement.RightTop" Title="">
            <ContentTemplate>
                <div>
                @((MarkupString)AllUsersBurnStr)
                </div>
            </ContentTemplate>
            <ChildContent>
                @context.BurnStr
            </ChildContent>
        </Popover>
        }
    </Column>
@if (DisplayMode != "ShowOnlyWorkforce")
{
    <Column Width="75" TData="string" title="Production" Sortable="false">
        @if (context.Parent != null)
        {
        string AllUserOrderProductions = string.Join("<br/>", context.UserOrderProductions);
        <Popover Placement="@Placement.RightTop" Title="">
            <ContentTemplate>
                <div>
                @((MarkupString)AllUserOrderProductions)
                </div>
            </ContentTemplate>
            <ChildContent>
                @context.ProduceStr
            </ChildContent>
        </Popover>
        }
    </Column>
}
    <Column Width="75" TData="string" title="Overall" Sortable="false">
        @context.OverallStr
    </Column>
    <Column Width="75" TData="string" title="Units Available" Sortable="false">
        @if (context.Parent != null)
        {
        string AllUserUnitsAvailable = string.Join("<br/>", context.UserMaterialAmounts);
        <Popover Placement="@Placement.RightTop" Title="">
            <ContentTemplate>
                <div>
                @((MarkupString)AllUserUnitsAvailable)
                </div>
            </ContentTemplate>
            <ChildContent>
                @context.UnitsAvailStr
            </ChildContent>
        </Popover>
        }
    </Column>
    <Column Width="75" TData="double" @bind-Field="@context.DaysUntilExhaustion" title="Days Until Exhaustion" Sortable="true">
        <div><span style="background-color:@(GetBackgroundColor(context.DaysUntilExhaustion))">@context.DaysUntilExhaustionStr</span></div>
    </Column>
    <Column Width="75" TData="string" Title="Units To Yellow">
        @GetUnitsToYellow(context)
    </Column>
    @if (!ShouldShowUserNames)
    {
        <Column @bind-Field="@context.LastUpdate" Title="" Sortable="true">
            <FIOWeb.Components.Burn.LastUpdateNotify Context="context"/>
        </Column>
    }
    else
    {
        <Column TData="string" Title="" Sortable="false"/>
    }
    </Table>
}
</FIOWeb.Components.LoadingWrapper>
